<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class ProdSubsidiadoFilialService {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function saveProduct($conditions){
	    try{
    	    $params = array(
        	    ':CDFILIAL'  => $conditions[0]['CDFILIAL'],
                ':CDPRODUTO' => $conditions[0]['CDPRODUTO'],
                ':NRORG'     => $conditions[0]['NRORG']
    	    );
    	    $this->entityManager->getConnection()->executeQuery(self::ADD_PRODUCT, $params);
	    } catch(Exception $e){
	        throw $e;
	    }
	}
	
	public function autoSaveProduct($conditions){
	    if($conditions['INTERVALISTA'] == 'L'){
	        try{
	            foreach($conditions['CDPRODUTO'] as $produto){
    	            $params = array(
    	                ':CDPRODUTO' => $produto,
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'  => $conditions['CDFILIAL']
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_PRODUCT, $params);
	            }
	        } catch (Exception $e){
	            throw $e;
	        }
	    } elseif($conditions['INTERVALISTA'] == 'I'){
	    	try{
	    		$params = array(
	    			':CDFILIAL'  => $conditions['CDFILIAL'],
	    			':NRORG'	 => $conditions['NRORG'],
	    			':CDPRODINI' => $conditions['CDPRODINI'],
	    			':CDPRODFIN' => $conditions['CDPRODFIN']
	    		);
	    		$prodLista =  $this->entityManager->getConnection()->fetchAll(self::GET_PROD_INTERVALO, $params);
	    		foreach($prodLista as $produto){
	    			$params = array(
    	                ':CDPRODUTO' => $produto['CDPRODUTO'],
    	                ':NRORG'     => $conditions['NRORG'],
    	                ':CDFILIAL'  => $conditions['CDFILIAL']
    	            );
    	            $this->entityManager->getConnection()->executeQuery(self::ADD_PRODUCT, $params);
	    		}
	    	} catch(Exception $e){
	    		throw $e;
	    	}
	    }
	}
	
	public function deleteChecked($conditions){
		foreach($conditions as $produto){
			try{
				$params = array(
					':CDFILIAL'  => $produto['CDFILIAL'],
					':NRORG'	 => $produto['NRORG'],
					':CDPRODUTO' => $produto['CDPRODUTO'],
				);
				$this->entityManager->getConnection()->executeQuery(self::DELETE_CHECKED_PRODUCTS, $params);
			} catch (Exception $e){
				throw $e;
			}
		}
	}
	
	
	const ADD_PRODUCT = "
	INSERT INTO PRODSUBSIFILI 
	    (CDFILIAL, CDPRODUTO, NRORG)
    VALUES 
        (:CDFILIAL, :CDPRODUTO, :NRORG)";

	const GET_PROD_INTERVALO = "
		SELECT PF.CDFILIAL, PF.CDPRODUTO, PR.CDARVPROD, PR.NMPRODUTO, PR.NRORG
		FROM PRODFILI PF, PRODUTO PR
		WHERE (PR.CDPRODUTO  = PF.CDPRODUTO)
		  AND (PF.CDFILIAL     = :CDFILIAL)
		  AND (PF.IDPRODATIV   = 'A')
		  AND (PR.NRORG        = :NRORG)
		  AND (PF.CDPRODUTO BETWEEN :CDPRODINI AND :CDPRODFIN)
		  AND (PR.CDNVPRODUTO IN (SELECT MAX(CDNVPRODUTO) FROM PRODUTO))
		  AND (PF.CDPRODUTO NOT IN (SELECT PS.CDPRODUTO
		                            FROM PRODSUBSIFILI PS, PRODFILI PF, PRODUTO PR
		                            WHERE (PS.CDFILIAL   = PF.CDFILIAL)
		                              AND (PS.CDPRODUTO    = PF.CDPRODUTO)
		                              AND (PR.CDPRODUTO    = PS.CDPRODUTO)
		                              AND (PS.CDFILIAL     = :CDFILIAL)
		                              AND (PR.NRORG        = :NRORG)
		                              AND (PF.IDPRODATIV   = 'A')
		                              AND (PR.CDNVPRODUTO IN (SELECT MAX(CDNVPRODUTO) FROM PRODUTO))
		                            ))
		ORDER BY PF.CDFILIAL, PF.CDPRODUTO
	";

	const DELETE_CHECKED_PRODUCTS = "
	DELETE FROM PRODSUBSIFILI
	WHERE CDFILIAL = :CDFILIAL
		AND NRORG = :NRORG
		AND CDPRODUTO = :CDPRODUTO
	";	
}